<template>
  <v-container>
    <v-row>
      <v-col>
        <v-row>
          <v-col>
            <h3 class="display-1">Certificar información</h3>
            <h5 class="body-2">
              En este apartado podrás certificar los datos previamente cargados,
              envíalos a certificar y recibe una notificación cuando el proceso
              haya terminado.
            </h5>
          </v-col>
        </v-row>
        <v-row>
          <v-col>
            <v-data-table
              v-model="selected"
              :headers="tab ? headersCertified : headersNew"
              :items="tab ? desserts : newDesserts"
              :items-per-page="5"
              :single-select="singleSelect"
              :item-key="headersCertified[0] ? headersCertified[0].value : ''"
              show-select
              class="elevation-1"
              data-cy="data_table_certificate"
            >
              <template v-slot:top>
                <v-row no-gutters align="center" class="actions">
                  <v-col
                    :class="{
                      'pt-5': $vuetify.breakpoint.smAndDown,
                      'pb-5': $vuetify.breakpoint.sm,
                      'px-5': $vuetify.breakpoint.smAndDown
                    }"
                    cols="12"
                    md="8"
                    order-md="2"
                  >
                    <v-row justify="center" justify-md="end" dense>
                      <v-dialog
                        v-model="dialogNew"
                        max-width="500px"
                        scrollable
                        data-cy="dialog_new_cell"
                      >
                        <template v-slot:activator="{ on }">
                          <v-col
                            :class="{ shrink: $vuetify.breakpoint.mdAndUp }"
                          >
                            <v-btn
                              @click="dialogNew = true"
                              v-on="on"
                              :block="$vuetify.breakpoint.smAndDown"
                              data-cy="new_cell"
                            >
                              <v-icon left>mdi-table</v-icon>
                              NUEVA CELDA
                            </v-btn>
                          </v-col>
                        </template>
                        <v-form v-model="valid">
                          <v-card>
                            <v-card-title
                              class="headline grey lighten-2"
                              primary-title
                            >
                              Agregar nuevo registro
                            </v-card-title>
                            <v-divider></v-divider>
                            <v-card-text class="mt-5">
                              <v-col cols="12">
                                <v-text-field
                                  v-model="editedItem.titular"
                                  label="Nombre"
                                  data-cy="titular_new_cell"
                                ></v-text-field>
                              </v-col>
                              <v-col cols="12">
                                <v-text-field
                                  v-model="editedItem.mun_origen"
                                  label="Municipio de origen"
                                  data-cy="mun_new_cell"
                                ></v-text-field>
                              </v-col>
                              <v-col cols="12">
                                <v-text-field
                                  v-model="editedItem.estado_origen"
                                  label="Estado"
                                  data-cy="estado_new_cell"
                                ></v-text-field>
                              </v-col>
                              <v-col cols="12">
                                <v-text-field
                                  v-model="editedItem.com_origen"
                                  label="Comunidad de origen"
                                  data-cy="com_new_cell"
                                ></v-text-field>
                              </v-col>
                              <v-col cols="12">
                                <v-text-field
                                  v-model="editedItem.time"
                                  label="Tiempo de laboración"
                                  data-cy="time_new_cell"
                                ></v-text-field>
                              </v-col>
                              <v-col cols="12">
                                <v-text-field
                                  v-model="editedItem.tec_art"
                                  label="Técnica que trabaja"
                                  data-cy="tec_new_cell"
                                ></v-text-field>
                              </v-col>
                            </v-card-text>
                            <v-divider></v-divider>
                            <v-card-actions>
                              <div class="flex-grow-1"></div>
                              <v-btn
                                @click="dialogNew = false"
                                color="primary"
                                text
                              >
                                Cerrar
                              </v-btn>
                              <v-btn
                                @click="save"
                                color="primary"
                                text
                                data-cy="save_new_cell"
                              >
                                Guardar
                              </v-btn>
                            </v-card-actions>
                          </v-card>
                        </v-form>
                      </v-dialog>
                      <v-col :class="{ shrink: $vuetify.breakpoint.mdAndUp }">
                        <v-btn
                          :to="{ path: 'load-data' }"
                          :block="$vuetify.breakpoint.smAndDown"
                          data-cy="upload_new_data"
                        >
                          <v-icon left>mdi-database</v-icon>
                          CARGAR NUEVOS DATOS
                        </v-btn>
                      </v-col>
                      <v-col :class="{ shrink: $vuetify.breakpoint.mdAndUp }">
                        <v-btn
                          :disabled="selected.length <= 0"
                          :block="$vuetify.breakpoint.smAndDown"
                          :class="{ 'mr-2': $vuetify.breakpoint.mdAndUp }"
                          @click="openDialogBlockchain"
                          color="primary"
                          data-cy="certify"
                        >
                          CERTIFICAR
                        </v-btn>
                      </v-col>
                    </v-row>
                  </v-col>
                  <v-col cols="12" md="4" order-md="1">
                    <v-tabs v-model="tab" color="primary" height="60">
                      <v-tab data-cy="tab_without_certificator">
                        SIN CERTIFICAR
                      </v-tab>
                      <v-tab data-cy="tab_certificates">
                        CERTIFICADOS
                      </v-tab>
                    </v-tabs>
                  </v-col>
                </v-row>
              </template>
            </v-data-table>
          </v-col>
        </v-row>
      </v-col>
      <v-dialog
        v-model="dialogBlockhain"
        width="420"
        data-cy="dialog_blockchain_network"
      >
        <v-card>
          <v-card-title class="headline grey lighten-2" primary-title>
            <h5>
              Elige la blockchain en la que quieres que se escriban tus
              certificados
            </h5>
          </v-card-title>
          <v-card-text class="mt-5">
            <v-form v-model="valid">
              <v-radio-group
                v-model="netBlockchain"
                data-cy="radio_group_network"
              >
                <v-radio
                  :key="1"
                  label="Ethereum"
                  value="ethereum"
                  data-cy="ethereum"
                ></v-radio>
                <v-radio
                  :key="2"
                  label="Bitcoin"
                  value="bitcoin"
                  data-cy="bitcoin"
                ></v-radio>
                <v-radio
                  :key="3"
                  label="RSK"
                  value="rsk"
                  data-cy="rsk"
                ></v-radio>
                <v-radio
                  :key="4"
                  label="BFA"
                  value="bfa"
                  data-cy="bfa"
                ></v-radio>
                <v-radio
                  :key="5"
                  label="ETC Labs"
                  value="etc"
                  data-cy="etcLabs"
                ></v-radio>
              </v-radio-group>
            </v-form>
          </v-card-text>
          <v-divider></v-divider>
          <v-card-actions>
            <div class="flex-grow-1"></div>
            <v-btn @click="dialogBlockhain = false" color="primary" text>
              Cerrar
            </v-btn>
            <v-btn
              @click="certify"
              color="primary"
              text
              data-cy="acept_newtwork"
            >
              Aceptar
            </v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="notification" width="500" data-cy="dialog_confirm">
        <v-card>
          <v-card-title class="headline grey lighten-2" primary-title>
            Certificando...
          </v-card-title>
          <v-card-text class="mt-5">
            <h3 class="body-1">
              Tus datos han sido mandados a certificar, podrás revisarlos en 5
              horas.
            </h3>
          </v-card-text>
          <v-divider></v-divider>
          <v-card-actions>
            <div class="flex-grow-1"></div>
            <v-btn @click="notification = false" color="primary" text>
              Cerrar
            </v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </v-row>
  </v-container>
</template>

<script>
import * as Papa from 'papaparse'
import * as d3 from 'd3'
import axios from 'axios'

export default {
  data() {
    return {
      tab: 0,
      dialogBlockhain: false,
      notification: false,
      netBlockchain: 'bitcoin',
      dialogNew: false,
      valid: true,
      singleSelect: false,
      filter: 'All',
      currentUser: '',
      currentUserEmail: '',
      selected: [],
      /**
       * @todo Dynamic headers defined by collection or CSV
       */
      headersNew: [
        { text: 'Nombre', value: 'titular' },
        { text: 'Estado', value: 'estado_origen' },
        { text: 'Municipio de origen', value: 'mun_origen' },
        { text: 'Comunidad de origen', value: 'com_origen' },
        { text: 'Tiempo de laboración', value: 'time' },
        { text: 'Técnica que trabaja', value: 'tec_art' }
      ],
      headersCertified: [
        { text: 'Nombre', value: 'titular' },
        { text: 'Estado', value: 'estado_origen' },
        { text: 'Municipio de origen', value: 'mun_origen' },
        { text: 'Comunidad de origen', value: 'com_origen' },
        { text: 'Tiempo de laboración', value: 'time' },
        { text: 'Técnica que trabaja', value: 'tec_art' },
        { text: 'Fecha', value: 'fecha' },
        { text: 'QR', value: 'qr' },
        { text: 'URL', value: 'url' }
      ],
      desserts: [],
      newDesserts: [],
      editedIndex: -1,
      editedItem: {
        titular: '',
        mun_origen: '',
        estado_origen: '',
        com_origen: '',
        time: '',
        tec_art: ''
      }
    }
  },
  beforeMount() {
    this.getData()
  },
  mounted() {
    this.checkFirebase()
  },
  methods: {
    checkFirebase() {
      const self = this
      this.$firebase.auth().onAuthStateChanged(
        function(user) {
          if (user) {
            self.currentUser = user.displayName
            self.currentUserEmail = user.email
            user.getIdToken().then(function(accessToken) {})
          } else {
          }
        },
        function(error) {
          console.error(error)
        }
      )
    },
    certify() {
      this.dialogBlockhain = false
      const self = this
      const promises = []
      this.selected.forEach((item) => {
        const ref = item.ref
        promises.push(
          this.$firebase
            .firestore()
            .doc(ref)
            .update({
              certify: true,
              is_certified: false,
              fecha: d3.timeFormat('%Y-%m-%d')(new Date())
            })
        )
      })
      Promise.all(promises).then(() => {
        self.desserts = []
        self.newDesserts = []
        self.getData()
        self.notification = true
        this.createCsv(this.selected)
      })
    },
    /** Generate CSV with data selected */
    createCsv(data) {
      const i = Papa.unparse(data)
      const file = new Blob([i], {
        type: 'data:text/csv;charset=utf-8'
      })
      const blockchain = this.netBlockchain
      const date = d3.timeFormat('%Y_%m_%d_%H_%M_%S')(new Date())
      file.name = `${blockchain}_${date}.csv`
      this.saveCsv(file)
    },
    /** Send file to storage in firebase */
    saveCsv(file) {
      const self = this
      const fileRef = this.$firebase
        .storage()
        .ref()
        .child('certificados/' + file.name)
      fileRef.put(file).then(function(snapshot) {
        /**
         * @todo #4 Move to a email service
         */
        /** Send email for us */
        axios.post(process.env.SENDGRID_ENDPOINT, {
          usuario: self.currentUser ? self.currentUser : 'Hola',
          nameDoc: file.name
        })
      })
    },
    /** Get data for collection in firebase */
    getCertificate() {
      return this.$firebase
        .firestore()
        .collection('certificateDataCollection')
        .get()
    },
    /** Clasification in New or Certify */
    getData() {
      const self = this
      this.getCertificate().then(function(certificates) {
        certificates.forEach((doc) => {
          const data = {
            ref: doc.ref.path,
            ...doc.data(),
            id: doc.id
          }
          if (data.is_certified || data.certify) {
            data.estado_origen = data.is_certified ? 'Certificado' : 'En espera'
            self.desserts.push(data)
          } else {
            self.newDesserts.push(data)
          }
        })
      })
    },
    /** Add new item to array for show in table */
    save() {
      if (this.editedIndex > -1) {
        Object.assign(this.newDesserts[this.editedIndex], this.editedItem)
      } else {
        this.newDesserts.push(this.editedItem)
      }
      this.createDialogInfo(this.editedItem)
      this.dialogNew = false
    },
    /** Create data in firebase from dialog */
    createDialogInfo(item) {
      this.$firebase
        .firestore()
        .collection('certificateDataCollection')
        .add(item)
        .then(() => {
          this.$firebase
            .firestore()
            .collection('certificateDataCollection')
            .onSnapshot(
              (querySnapshot) => {
                console.log(`Received query snapshot of size ${querySnapshot}`)
              },
              (err) => {
                console.log(`Encountered error: ${err}`)
              }
            )
        })
    },
    openDialogBlockchain() {
      this.dialogBlockhain = true
    }
  }
}
</script>

<style lang="scss" scoped>
.actions {
  background-color: rgba(229, 231, 232, 1);
}
::v-deep.theme--light.v-tabs > .v-tabs-bar {
  background-color: rgba(229, 231, 232, 1) !important;
}
@media (min-width: 1904px) {
  .container {
    max-width: 1264px;
  }
}
</style>
